import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;


public class FileTools {
	
	
	
	public int maxSequencia(String strArquivo) throws IOException{
		int maxSequencia = 0;
		int nLinhasPercorridas = 0;
		BufferedReader arquivo = new BufferedReader(new FileReader(strArquivo));
		int nLinhas = numeroLinhasArquivo(arquivo);
		arquivo.close();
		
		arquivo = new BufferedReader(new FileReader(strArquivo));
		
		String linha = arquivo.readLine();
		nLinhasPercorridas++;
		nLinhasPercorridas++;
		while(nLinhasPercorridas < nLinhas && linha != null){
			int n = 0;
			while(!linha.equals("") && nLinhasPercorridas < nLinhas+1 && !linha.contains(">")){
				n =  n + linha.length();
				//System.out.println(linha.length());
				linha = arquivo.readLine();
				nLinhasPercorridas++;
			}
			if(n > maxSequencia) {
				maxSequencia = n;
				System.out.println("Max = "+maxSequencia);
				System.out.println(nLinhasPercorridas);
			}
			linha = arquivo.readLine();
			nLinhasPercorridas++;
		}
		arquivo.close();
		return maxSequencia;
		
	}
	public void carregarArquivoFastaDB(String dbNome, String strArquivo,String tbNome) throws IOException, ClassNotFoundException, SQLException, InstantiationException, IllegalAccessException{
		
		BufferedReader arquivo;
		BufferedWriter log = new BufferedWriter(new FileWriter("log.txt"));
		DBTools db;	
		db = new DBTools(dbNome);
		db.conectar();
		int nLinhas;
		String linha;
		arquivo = new BufferedReader(new FileReader(strArquivo));
		nLinhas = numeroLinhasArquivo(arquivo);
		arquivo = new BufferedReader(new FileReader(strArquivo));
		float nLinhasPercorridas = 0;
        int nInseridas = 0;
		linha = arquivo.readLine();
		//System.out.println(linha);
		nLinhasPercorridas++;
		
		
		
		
		while(nLinhasPercorridas < nLinhas && linha!=null){
				if(linha.contains(">gi|")){
					String[] valores;
					String[] campos;
					valores = new String[2];
					campos = new String[2];
					StringBuilder gi = new StringBuilder("'");
					int i = 4;
					while(linha.charAt(i)!= '|'){
						gi.append(linha.charAt(i));
						i++;
					}
					gi.append("'");
					//nGi = Integer.parseInt(gi.toString());
					StringBuilder sequenciaTmp = new StringBuilder("'");
					while(!linha.equals("")){
						linha = arquivo.readLine();
						String[] str = linha.split("\n");
						sequenciaTmp.append(str[0]);
						nLinhasPercorridas++;
						
					}
					sequenciaTmp.append("'");
					campos[0] = "gi";
					campos[1] = "tag";
					valores[0] = gi.toString();
					valores[1] = sequenciaTmp.toString();
					try{
						//System.out.println(gi.toString());
						//System.out.println(sequenciaTmp.toString());
						db.inserirDadosTabela(tbNome, campos, valores);
						
						nInseridas++;	
					}catch(SQLException e){
						String stack = e.getMessage();
						log.write(stack);
						
					}
					
					
				

				}
				linha = arquivo.readLine();
				nLinhasPercorridas++;
			//	System.out.println(nLinhasPercorridas);
				if(nLinhasPercorridas%5000 ==0 || nLinhas == nLinhasPercorridas){
					Calendar calendar = new GregorianCalendar();  
			    	Date trialTime = new Date();  
			    	calendar.setTime(trialTime);  
			    	System.out.print(calendar.get(Calendar.HOUR_OF_DAY)+"h"+ calendar.get(Calendar.MINUTE)+"min"+calendar.get(Calendar.SECOND)+"s");  
			    	System.out.println("->Linhas Percorridas: "+nLinhasPercorridas);
				}
				
		}
		db.desconectar();
		arquivo.close();	
	}
	
	
	
	public int numeroLinhasArquivo(BufferedReader arquivo) throws IOException{
		int nLinhas;
		nLinhas = 0;
		while(arquivo.readLine()!=null){
			nLinhas++;
		}
		return nLinhas;
	}
	public int numeroSequenciasArquivo(BufferedReader arquivo) throws IOException{
		int nSeq;
		String linha;
		nSeq = 0;
		while((linha = arquivo.readLine())!=null){
			if(linha.contains(">gi")){
				nSeq++;
			}
		}
		return nSeq;
	}
	
	
}
