import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Date;
import java.util.Calendar;
import java.util.GregorianCalendar;


public class HTML {
	
	String strArq;
	String strQuery;
	String inicioHtml;
	String fimHtml;
	BufferedWriter arquivo;
	LinhaTab[] linhasTab;
	int lastIndex;
	
	class LinhaTab {
		
		String[] campos;
		
		public LinhaTab(String linha){
			this.campos = linha.split(";");
		//	System.out.println(linha);
		//	System.out.println(campos[0]);
		//	System.out.println(campos[1]);
			
		}
		
		public void atualizar(String linha){
			this.campos = linha.split(";");
		}
		
		
		
	}
	
//	public inserirLinha(String linha){
//		this.linhasTab[]
//	}
	public HTML(String str, int nLinhas) throws IOException, ValorInvalidoException{
		
		this.strArq = str;
		//this.strQuery = query;
		this.arquivo = new BufferedWriter (new FileWriter(this.strArq)); 
		this.lastIndex = 0;
		
		if(nLinhas > 0){
			this.linhasTab = new LinhaTab[nLinhas];
		}
		else throw new ValorInvalidoException();
				
		this.inicioHtml = "<HTML>\n<HEAD> <CENTER><h1> FASTA Tools</h1></CENTER><br></HEAD><BODY style = font-family:calibri;color:#191970;font-size:25px>Relatorio de busca por <i>'";
		
		
		
	}
	
	public void close() throws IOException{
		this.arquivo.write(this.fimHtml);
		this.arquivo.close();
	}
	
	public void inserirLinhaTab(String linha){
		
		linhasTab[lastIndex] = new LinhaTab(linha);//split(";");
		//System.out.println(linhasTab[lastIndex].campos[0]);
		lastIndex++;
				
	}
	
	public void imprimirTabela(String destaque, String cor, int campoLinha) throws IOException{
		
		this.inicioHtml= this.inicioHtml+destaque.toUpperCase()+"'</i><br>"+
		getHora()+"<br></font><br><br><br>";
		this.fimHtml = "</BODY></HTML>";
		this.arquivo.write(inicioHtml);
		StringBuilder linha = new StringBuilder("<CENTER><table cellspacing=5>");//<tr style = background:#B0C4DE>");
		StringBuilder formatacaoCor = new StringBuilder("<b><font color = ");
		formatacaoCor.append(cor);
		formatacaoCor.append(">");
		formatacaoCor.append(destaque.toUpperCase());
		formatacaoCor.append("</font></b>");
		//LinhaTab cabecalho = linhasTab[0];
		
//		for(int i = 0; i < cabecalho.campos.length; i++ ){
//			linha.append("<td>");
//			linha.append(cabecalho.campos[i]);
//			linha.append("</td>");
//		}
//		
		linha.append("</tr>\n");
		arquivo.write(linha.toString());
	
		for(int i = 0; i < lastIndex ; i++){
			linha = new StringBuilder("");
			if(i % 2 == 1){
				linha.append("<tr style = background:white>\n");
				
			}else{
				linha.append("<tr style = background:#B0C4DE>\n");
			}
			
			
			LinhaTab temp = linhasTab[i];
			String[] campos = temp.campos;
			
			
			for(int j = 0; j < campos.length; j++){
				linha.append("<td>");
				if( (cor != null) && (j == campoLinha) && i >0 ){
					//System.out.println(linha);
					String[] partesStr = campos[j].split(destaque.toUpperCase());
					
					if(campos[j].indexOf(destaque) == 0){
						linha.append(formatacaoCor);
						for(int k = 0; k < partesStr.length; k++){
							if(!partesStr[k].equals("")){
								linha.append(partesStr[k]);
							}
							
						}
						
					}
					else if(campos[j].indexOf(destaque)+destaque.length() == campos[j].length()){
						linha.append(partesStr[0]);
						linha.append(formatacaoCor);
						System.out.println(linha);
						
					}
					else{
						linha.append(partesStr[0]);
						linha.append(formatacaoCor);
						linha.append(partesStr[1]);
					}
					
					
				}
				else linha.append(campos[j]);
				
				linha.append("</td>");
				
			}
			linha.append("</tr>");
			this.arquivo.write(linha.toString());
		//	System.out.println(linha.toString());
			
		}
		linha.append("</table></CENTER>");
		
	}
	
	
	public String getHora(){
		
		Calendar calendar = new GregorianCalendar();  
    	Date trialTime = new Date();  
    	calendar.setTime(trialTime);
    	
    	return "Data: "+ calendar.get(Calendar.DAY_OF_MONTH)+"/"+ (calendar.get(Calendar.MONTH)+1)+"/"+
    	calendar.get(Calendar.YEAR)+"<br>Hora: "+calendar.get(Calendar.HOUR_OF_DAY)+"h"+calendar.get(Calendar.MINUTE)+"min"+calendar.get(Calendar.SECOND)+"seg";  
    	
	}
	
	
}
